OpenVDB: ArrayPack Struct Reference

OpenVDB 13.0.0

Loading...
Searching...
No Matches
ArrayPack Struct Reference

ArrayPacks represent temporary container creations of arbitrary sizes, typically generated through the use of curly braces {}. More...

`#include <openvdb_ax/ast/AST.h>`

Inheritance diagram for ArrayPack:

## Public Types
using | UniquePtr = std::unique_ptr<ArrayPack>
enum | NodeType { TreeNode , StatementListNode , BlockNode , ConditionalStatementNode , CommaOperatorNode , LoopNode , KeywordNode , AssignExpressionNode , CrementNode , UnaryOperatorNode , BinaryOperatorNode , TernaryOperatorNode , CastNode , AttributeNode , FunctionCallNode , ExternalVariableNode , DeclareLocalNode , ArrayPackNode , ArrayUnpackNode , LocalNode , ValueBoolNode , ValueInt16Node , ValueInt32Node , ValueInt64Node , ValueFloatNode , ValueDoubleNode , ValueStrNode }
| An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType. More...
using | Ptr = std::shared_ptr<Node>

## Public Member Functions
| ArrayPack (Expression *expression)
| Construct a new ArrayPack with a single expression, transferring ownership of the expression to the ArrayPack and updating parent data on the expression. If the expression is a nullptr, it is ignored.
| ArrayPack (const std::vector< Expression * > &arguments)
| Construct a new ArrayPack transferring ownership of any provided arguments to the ArrayPack and updating parent data on the arguments.
| ArrayPack (const ArrayPack &other)
| Deep copy constructor for a ArrayPack, performing a deep copy on all held arguments, ensuring parent information is updated.
| ~ArrayPack () override=default
ArrayPack * | copy () const override final
| The deep copy method for a Node.
NodeType | nodetype () const override
| Virtual method for accessing node type information.
const char * | nodename () const override
| Virtual method for accessing node name information.
const char * | subname () const override
| Virtual method for accessing node name information.
const Expression * | basetype () const override
| Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.
size_t | children () const override final
| Virtual method for accessing child information. Returns the number of children a given AST node owns.
const Expression * | child (const size_t i) const override final
| Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.
bool | replacechild (const size_t i, Node *node) override final
| Virtual method that attempted to replace a child at a given index with a provided node type.
size_t | size () const
| Alias for ArrayPack::children.
bool | empty () const
| Query whether this Expression list holds any valid expressions.
void | append (Expression *expr)
| Appends an argument to this ArrayPack, transferring ownership to the ArrayPack and updating parent data on the expression. If the expression is a nullptr, it is ignored.
Name/Type
template<typename NodeT>
bool | isType () const
| Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype().
Child Queries
int64_t | childidx () const
| Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree).
Replacement
bool | replace (Node *node)
| In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.
Parent
const Node * | parent () const
| Access a const pointer to this nodes parent.
void | setParent (Node *parent)
| Set this node's parent. This is used during construction of an AST and should not be used.

## Detailed Description

ArrayPacks represent temporary container creations of arbitrary sizes, typically generated through the use of curly braces {}.

## Member Typedef Documentation

## ◆ Ptr

using Ptr = std::shared_ptr<Node>
| inherited

## ◆ UniquePtr

using UniquePtr = std::unique_ptr<ArrayPack>

## Member Enumeration Documentation

## ◆ NodeType

enum NodeType
| inherited

An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType.

Note
  This is sometimes referred to as "manual RTTI". We use this technique combine with single dispatch due to opting for CRTP on the main visitor and no templated virtual method support in C++. i.e. no way to double dispatch: visit<template T>(Visitor<T>*)
  Abstract (pure-virtual) nodes are not listed here. Node::isType should be used to determine if a node is of a given abstract type.

Enumerator
TreeNode |
StatementListNode |
BlockNode |
ConditionalStatementNode |
CommaOperatorNode |
LoopNode |
KeywordNode |
AssignExpressionNode |
CrementNode |
UnaryOperatorNode |
BinaryOperatorNode |
TernaryOperatorNode |
CastNode |
AttributeNode |
FunctionCallNode |
ExternalVariableNode |
DeclareLocalNode |
ArrayPackNode |
ArrayUnpackNode |
LocalNode |
ValueBoolNode |
ValueInt16Node |
ValueInt32Node |
ValueInt64Node |
ValueFloatNode |
ValueDoubleNode |
ValueStrNode |

## Constructor & Destructor Documentation

## ◆ ArrayPack() [1/3]

ArrayPack | ( | Expression * | expression | ) |
| inline

Construct a new ArrayPack with a single expression, transferring ownership of the expression to the ArrayPack and updating parent data on the expression. If the expression is a nullptr, it is ignored.

Parameters

  expression | The Expression to construct from

## ◆ ArrayPack() [2/3]

ArrayPack | ( | const std::vector< Expression * > & | arguments | ) |
| inline

Construct a new ArrayPack transferring ownership of any provided arguments to the ArrayPack and updating parent data on the arguments.

Parameters

  arguments | ArrayPack arguments

## ◆ ArrayPack() [3/3]

ArrayPack | ( | const ArrayPack & | other | ) |
| inline

Deep copy constructor for a ArrayPack, performing a deep copy on all held arguments, ensuring parent information is updated.

Parameters

  other | A const reference to another ArrayPack to deep copy

## ◆ ~ArrayPack()

~ArrayPack | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ append()

void append | ( | Expression * | expr | ) |
| inline

Appends an argument to this ArrayPack, transferring ownership to the ArrayPack and updating parent data on the expression. If the expression is a nullptr, it is ignored.

## ◆ basetype()

const Expression * basetype | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.

Reimplemented from Node.

## ◆ child()

const Expression * child | ( | const size_t | i | ) | const
| inlinefinaloverridevirtual

Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.

Implements Node.

## ◆ childidx()

int64_t childidx | ( |  | ) | const
| inlineinherited

Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree).

Returns
  The child index of this node

## ◆ children()

size_t children | ( |  | ) | const
| inlinefinaloverridevirtual

Virtual method for accessing child information. Returns the number of children a given AST node owns.

Implements Node.

## ◆ copy()

ArrayPack * copy | ( |  | ) | const
| inlinefinaloverridevirtual

The deep copy method for a Node.

Implements Expression.

## ◆ empty()

bool empty | ( |  | ) | const
| inline

Query whether this Expression list holds any valid expressions.

Returns
  True if this node if empty, false otherwise

## ◆ isType()

template<typename NodeT>

bool isType | ( |  | ) | const
| inlineinherited

Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype().

Template Parameters

  NodeT | The node type to query against.

Returns
  True if this node is of the given type, false otherwise.

## ◆ nodename()

const char * nodename | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node name information.

Implements Node.

## ◆ nodetype()

NodeType nodetype | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node type information.

Implements Node.

## ◆ parent()

const Node * parent | ( |  | ) | const
| inlineinherited

Access a const pointer to this nodes parent.

Note
  Can be a nullptr if this is the top most node in an AST (usually a Tree)

Returns
  A const pointer to this node's parent node

## ◆ replace()

bool replace | ( | Node * | node | ) |
| inlineinherited

In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.

Note
  A replacement will fail if this node is the top most node within an AST hierarchy or if the provided node type is not a compatible type for the required abstract storage. For example, if this node is an Attribute being held on a BinaryOperator, only concrete nodes derived from an Expression can be used as a replacement.
  This method will dynamic_cast the provided node to check to see if it's a compatible type.

Parameters

  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, resulting in destruction of this class and ownership transferal of the provided node. False otherwise, where this and the provided node are unchanged.

## ◆ replacechild()

bool replacechild | ( | const size_t | i,
|  | Node * | node )
| inlinefinaloverridevirtual

Virtual method that attempted to replace a child at a given index with a provided node type.

Reimplemented from Node.

## ◆ setParent()

void setParent | ( | Node * | parent | ) |
| inlineinherited

Set this node's parent. This is used during construction of an AST and should not be used.

Parameters

  parent | The parent to set

## ◆ size()

size_t size | ( |  | ) | const
| inline

Alias for ArrayPack::children.

## ◆ subname()

const char * subname | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node name information.

Implements Node.